JOINT_OPTIONS = {
    "scale": {
        "type": float,
    },
    "type": {
        "type": "select",
        "options": ["LINEAR", "ANGULAR"],
    },
    "ferror": {
        "type": float,
    },
    "min_ferror": {
        "type": float,
    },
    "min_limit": {
        "type": float,
    },
    "max_limit": {
        "type": float,
    },
    "max_velocity": {
        "type": float,
    },
    "max_acceleration": {
        "type": float,
    },
    "stepgen_maxaccel": {
        "type": float,
    },
    "feedback": {
        "type": str,
    },
    "home_sequence": {
        "type": int,
    },
    "home": {
        "type": float,
    },
    "home_offset": {
        "type": float,
    },
    "home_search_vel": {
        "type": float,
    },
    "home_latch_vel": {
        "type": float,
    },
    "home_final_vel": {
        "type": float,
    },
    "home_ignore_limits": {
        "type": "select",
        "options": ["YES", "NO"],
    },
    "home_use_index": {
        "type": "select",
        "options": ["YES", "NO"],
    },
}

RIO_FUNCTION_DEFAULTS = {
    "jog": {
        "wheel": {
            "filter": {"type": bool, "default": False, "help": "activate lowpassfilter for the jog-wheel"},
            "filter_gain": {"type": float, "default": 0.02, "help": "lowpass filter gain)"},
            "filter_scale": {"type": float, "default": 1.0, "help": "lowpass filter scale"},
            "scale": {"type": float, "default": 0.005, "help": "default jog-wheel scale (if no scale selector is set)"},
            "scale_0": {"type": float, "default": 0.0, "help": "1. jog-wheel scale (if scale selector is set)"},
            "scale_1": {"type": float, "default": 0.001, "help": "2. jog-wheel scale (if scale selector is set)"},
            "scale_2": {"type": float, "default": 0.010, "help": "3. jog-wheel scale (if scale selector is set)"},
            "scale_3": {"type": float, "default": 0.050, "help": "4. jog-wheel scale (if scale selector is set)"},
        },
        "keys": {
            "speed": {"type": float, "default": 1.0, "help": "default jog-button speed (if no speed selector is set)"},
            "speed_0": {"type": float, "default": 1.0, "help": "1. jog-button speed (if speed selector is set)"},
            "speed_1": {"type": float, "default": 10.0, "help": "2. jog-button speed (if speed selector is set)"},
            "speed_2": {"type": float, "default": 100.0, "help": "3. jog-button speed (if speed selector is set)"},
            "speed_3": {"type": float, "default": 1000.0, "help": "4. jog-button speed (if speed selector is set)"},
        },
    },
}

RIO_FUNCTIONS = {
    "inout": {},
    "output": {
        "jog.selected-x": {"help": "X is the selected axis", "type": bool},
        "jog.selected-y": {"help": "Y is the selected axis", "type": bool},
        "jog.selected-z": {"help": "Z is the selected axis", "type": bool},
        "jog.position": {"help": "Position of selected axis", "type": float},
    },
    "input": {
        "jog.wheel": {"help": "Jog-Wheel", "type": float},
        "jog.wheel_x": {"help": "Jog-Wheel X-Axis", "type": float},
        "jog.wheel_y": {"help": "Jog-Wheel Y-Axis", "type": float},
        "jog.wheel_z": {"help": "Jog-Wheel Z-Axis", "type": float},
        "jog.select-x": {"help": "Jog-Select X-Axis", "type": bool},
        "jog.select-y": {"help": "Jog-Select Y-Axis", "type": bool},
        "jog.select-z": {"help": "Jog-Select Z-Axis", "type": bool},
        "jog.plus": {"help": "Jog selected axis plus", "type": bool},
        "jog.minus": {"help": "Jog selected axis minus", "type": bool},
        "jog.fast": {"help": "Jog set fast", "type": bool},
    },
}

LINUXCNC_SIGNALS = {
    "inout": {"joint.0.index-enable": {"help": "Joint", "type": bool}, "spindle.0.index-enable": {"help": "", "type": bool}},
    "input": {
        "axis.x.eoffset-clear": {"help": "Axis", "type": bool},
        "axis.x.eoffset-counts": {"help": "Axis", "type": int},
        "axis.x.eoffset-enable": {"help": "Axis", "type": bool},
        "axis.x.eoffset-scale": {"help": "Axis", "type": float},
        "axis.x.jog-accel-fraction": {"help": "Axis", "type": float},
        "axis.x.jog-counts": {"help": "Axis", "type": int},
        "axis.x.jog-enable": {"help": "Axis", "type": bool},
        "axis.x.jog-scale": {"help": "Axis", "type": float},
        "axis.x.jog-vel-mode": {"help": "Axis", "type": bool},
        "axisui.notifications-clear": {"help": "", "type": bool},
        "axisui.notifications-clear-error": {"help": "", "type": bool},
        "axisui.notifications-clear-info": {"help": "", "type": bool},
        "axisui.resume-inhibit": {"help": "", "type": bool},
        "hal_manualtoolchange.change": {"help": "", "type": bool},
        "hal_manualtoolchange.change_button": {"help": "", "type": bool},
        "hal_manualtoolchange.number": {"help": "", "type": int},
        "halui.abort": {"help": "", "type": bool},
        "halui.axis.x.analog": {"help": "Axis", "type": float},
        "halui.axis.x.increment": {"help": "Axis", "type": float},
        "halui.axis.x.increment-minus": {"help": "Axis", "type": bool},
        "halui.axis.x.increment-plus": {"help": "Axis", "type": bool},
        "halui.axis.x.minus": {"help": "Axis", "type": bool},
        "halui.axis.x.plus": {"help": "Axis", "type": bool},
        "halui.axis.x.select": {"help": "Axis", "type": bool},
        "halui.estop.activate": {"help": "", "type": bool},
        "halui.estop.reset": {"help": "", "type": bool},
        "halui.feed-override.count-enable": {"help": "", "type": bool},
        "halui.feed-override.counts": {"help": "", "type": int},
        "halui.feed-override.decrease": {"help": "", "type": bool},
        "halui.feed-override.direct-value": {"help": "", "type": bool},
        "halui.feed-override.increase": {"help": "", "type": bool},
        "halui.feed-override.reset": {"help": "", "type": bool},
        "halui.feed-override.scale": {"help": "", "type": float},
        "halui.flood.off": {"help": "", "type": bool},
        "halui.flood.on": {"help": "", "type": bool},
        "halui.home-all": {"help": "", "type": bool},
        "halui.joint.0.analog": {"help": "Joint", "type": float},
        "halui.joint.0.home": {"help": "Joint", "type": bool},
        "halui.joint.0.increment": {"help": "Joint", "type": float},
        "halui.joint.0.increment-minus": {"help": "Joint", "type": bool},
        "halui.joint.0.increment-plus": {"help": "Joint", "type": bool},
        "halui.joint.0.minus": {"help": "Joint", "type": bool},
        "halui.joint.0.plus": {"help": "Joint", "type": bool},
        "halui.joint.0.select": {"help": "Joint", "type": bool},
        "halui.joint.0.unhome": {"help": "Joint", "type": bool},
        "halui.lube.off": {"help": "", "type": bool},
        "halui.lube.on": {"help": "", "type": bool},
        "halui.machine.off": {"help": "", "type": bool},
        "halui.machine.on": {"help": "", "type": bool},
        "halui.max-velocity.count-enable": {"help": "", "type": bool},
        "halui.max-velocity.counts": {"help": "", "type": int},
        "halui.max-velocity.decrease": {"help": "", "type": bool},
        "halui.max-velocity.direct-value": {"help": "", "type": bool},
        "halui.max-velocity.increase": {"help": "", "type": bool},
        "halui.max-velocity.scale": {"help": "", "type": float},
        "halui.mdi-command-00": {"help": "", "type": bool},
        "halui.mdi-command-01": {"help": "", "type": bool},
        "halui.mdi-command-02": {"help": "", "type": bool},
        "halui.mdi-command-03": {"help": "", "type": bool},
        "halui.mdi-command-04": {"help": "", "type": bool},
        "halui.mdi-command-05": {"help": "", "type": bool},
        "halui.mdi-command-06": {"help": "", "type": bool},
        "halui.mist.off": {"help": "", "type": bool},
        "halui.mist.on": {"help": "", "type": bool},
        "halui.mode.auto": {"help": "", "type": bool},
        "halui.mode.joint": {"help": "", "type": bool},
        "halui.mode.manual": {"help": "", "type": bool},
        "halui.mode.mdi": {"help": "", "type": bool},
        "halui.mode.teleop": {"help": "", "type": bool},
        "halui.program.block-delete.off": {"help": "", "type": bool},
        "halui.program.block-delete.on": {"help": "", "type": bool},
        "halui.program.optional-stop.off": {"help": "", "type": bool},
        "halui.program.optional-stop.on": {"help": "", "type": bool},
        "halui.program.pause": {"help": "", "type": bool},
        "halui.program.resume": {"help": "", "type": bool},
        "halui.program.run": {"help": "", "type": bool},
        "halui.program.step": {"help": "", "type": bool},
        "halui.program.stop": {"help": "", "type": bool},
        "halui.rapid-override.count-enable": {"help": "", "type": bool},
        "halui.rapid-override.counts": {"help": "", "type": int},
        "halui.rapid-override.decrease": {"help": "", "type": bool},
        "halui.rapid-override.direct-value": {"help": "", "type": bool},
        "halui.rapid-override.increase": {"help": "", "type": bool},
        "halui.rapid-override.reset": {"help": "", "type": bool},
        "halui.rapid-override.scale": {"help": "", "type": float},
        "halui.spindle.0.brake-off": {"help": "", "type": bool},
        "halui.spindle.0.brake-on": {"help": "", "type": bool},
        "halui.spindle.0.decrease": {"help": "", "type": bool},
        "halui.spindle.0.forward": {"help": "", "type": bool},
        "halui.spindle.0.increase": {"help": "", "type": bool},
        "halui.spindle.0.override.count-enable": {"help": "", "type": bool},
        "halui.spindle.0.override.counts": {"help": "", "type": int},
        "halui.spindle.0.override.decrease": {"help": "", "type": bool},
        "halui.spindle.0.override.direct-value": {"help": "", "type": bool},
        "halui.spindle.0.override.increase": {"help": "", "type": bool},
        "halui.spindle.0.override.reset": {"help": "", "type": bool},
        "halui.spindle.0.override.scale": {"help": "", "type": float},
        "halui.spindle.0.reverse": {"help": "", "type": bool},
        "halui.spindle.0.start": {"help": "", "type": bool},
        "halui.spindle.0.stop": {"help": "", "type": bool},
        "iocontrol.0.emc-enable-in": {"help": "Estop input", "type": bool},
        "iocontrol.0.lube_level": {"help": "", "type": bool},
        "iocontrol.0.tool-changed": {"help": "", "type": bool},
        "iocontrol.0.tool-prepared": {"help": "", "type": bool},
        "joint.0.amp-fault-in": {"help": "Joint", "type": bool},
        "joint.0.home-sw-in": {"help": "Homeswitch input", "type": bool},
        "joint.0.jog-accel-fraction": {"help": "Joint", "type": float},
        "joint.0.jog-counts": {"help": "Joint", "type": int},
        "joint.0.jog-enable": {"help": "Joint", "type": bool},
        "joint.0.jog-scale": {"help": "Joint", "type": float},
        "joint.0.jog-vel-mode": {"help": "Joint", "type": bool},
        "joint.0.motor-pos-fb": {"help": "Joint", "type": float},
        "joint.0.neg-lim-sw-in": {"help": "Joint", "type": bool},
        "joint.0.pos-lim-sw-in": {"help": "Joint", "type": bool},
        "joint.1.home-sw-in": {"help": "Homeswitch input", "type": bool},
        "joint.2.home-sw-in": {"help": "Homeswitch input", "type": bool},
        "joint.3.home-sw-in": {"help": "Homeswitch input", "type": bool},
        "joint.4.home-sw-in": {"help": "Homeswitch input", "type": bool},
        "joint.5.home-sw-in": {"help": "Homeswitch input", "type": bool},
        "motion.adaptive-feed": {"help": "", "type": float},
        "motion.analog-in-00": {"help": "", "type": float},
        "motion.analog-in-01": {"help": "", "type": float},
        "motion.analog-in-02": {"help": "", "type": float},
        "motion.digital-in-00": {"help": "Digital Input: M66", "type": bool},
        "motion.digital-in-01": {"help": "Digital Input: M66", "type": bool},
        "motion.digital-in-02": {"help": "Digital Input: M66", "type": bool},
        "motion.digital-in-03": {"help": "Digital Input: M66", "type": bool},
        "motion.enable": {"help": "", "type": bool},
        "motion.feed-hold": {"help": "", "type": bool},
        "motion.feed-inhibit": {"help": "", "type": bool},
        "motion.homing-inhibit": {"help": "", "type": bool},
        "motion.jog-inhibit": {"help": "", "type": bool},
        "motion.jog-stop": {"help": "", "type": bool},
        "motion.jog-stop-immediate": {"help": "", "type": bool},
        "motion.probe-input": {"help": "Touch-Probe input", "type": bool},
        "spindle.0.amp-fault-in": {"help": "", "type": bool},
        "spindle.0.at-speed": {"help": "", "type": bool},
        "spindle.0.inhibit": {"help": "", "type": bool},
        "spindle.0.is-oriented": {"help": "", "type": bool},
        "spindle.0.orient-fault": {"help": "", "type": int},
        "spindle.0.revs": {"help": "", "type": float},
        "spindle.0.speed-in": {"help": "", "type": float},
    },
    "output": {
        "axis.x.eoffset": {"help": "Axis", "type": float},
        "axis.x.eoffset-request": {"help": "Axis", "type": float},
        "axis.x.kb-jog-active": {"help": "Axis", "type": bool},
        "axis.x.pos-cmd": {"help": "Axis", "type": float},
        "axis.x.teleop-pos-cmd": {"help": "Axis", "type": float},
        "axis.x.teleop-tp-enable": {"help": "Axis", "type": bool},
        "axis.x.teleop-vel-cmd": {"help": "Axis", "type": float},
        "axis.x.teleop-vel-lim": {"help": "Axis", "type": float},
        "axis.x.wheel-jog-active": {"help": "Axis", "type": bool},
        "axisui.abort": {"help": "", "type": bool},
        "axisui.error": {"help": "", "type": bool},
        "axisui.jog.x": {"help": "Jog", "type": bool},
        "hal_manualtoolchange.changed": {"help": "", "type": bool},
        "halui.axis.x.is-selected": {"help": "Axis", "type": bool},
        "halui.axis.x.pos-commanded": {"help": "Axis", "type": float},
        "halui.axis.x.pos-feedback": {"help": "Axis", "type": float},
        "halui.axis.x.pos-relative": {"help": "Axis", "type": float},
        "halui.estop.is-activated": {"help": "", "type": bool},
        "halui.feed-override.value": {"help": "", "type": float},
        "halui.flood.is-on": {"help": "", "type": bool},
        "halui.joint.0.has-fault": {"help": "Joint", "type": bool},
        "halui.joint.0.is-homed": {"help": "Joint", "type": bool},
        "halui.joint.0.is-selected": {"help": "Joint", "type": bool},
        "halui.joint.0.on-hard-max-limit": {"help": "Joint", "type": bool},
        "halui.joint.0.on-hard-min-limit": {"help": "Joint", "type": bool},
        "halui.joint.0.on-soft-max-limit": {"help": "Joint", "type": bool},
        "halui.joint.0.on-soft-min-limit": {"help": "Joint", "type": bool},
        "halui.joint.0.override-limits": {"help": "Joint", "type": bool},
        "halui.lube.is-on": {"help": "", "type": bool},
        "halui.machine.is-on": {"help": "", "type": bool},
        "halui.machine.units-per-mm": {"help": "", "type": float},
        "halui.max-velocity.value": {"help": "", "type": float},
        "halui.mist.is-on": {"help": "", "type": bool},
        "halui.mode.is-auto": {"help": "", "type": bool},
        "halui.mode.is-joint": {"help": "", "type": bool},
        "halui.mode.is-manual": {"help": "", "type": bool},
        "halui.mode.is-mdi": {"help": "", "type": bool},
        "halui.mode.is-teleop": {"help": "", "type": bool},
        "halui.program.block-delete.is-on": {"help": "", "type": bool},
        "halui.program.is-idle": {"help": "", "type": bool},
        "halui.program.is-paused": {"help": "", "type": bool},
        "halui.program.is-running": {"help": "", "type": bool},
        "halui.program.optional-stop.is-on": {"help": "", "type": bool},
        "halui.rapid-override.value": {"help": "", "type": float},
        "halui.spindle.0.brake-is-on": {"help": "", "type": bool},
        "halui.spindle.0.is-on": {"help": "", "type": bool},
        "halui.spindle.0.override.value": {"help": "", "type": float},
        "halui.spindle.0.runs-backward": {"help": "", "type": bool},
        "halui.spindle.0.runs-forward": {"help": "", "type": bool},
        "halui.tool.diameter": {"help": "", "type": float},
        "halui.tool.length_offset.a": {"help": "", "type": float},
        "halui.tool.length_offset.b": {"help": "", "type": float},
        "halui.tool.length_offset.c": {"help": "", "type": float},
        "halui.tool.length_offset.u": {"help": "", "type": float},
        "halui.tool.length_offset.v": {"help": "", "type": float},
        "halui.tool.length_offset.w": {"help": "", "type": float},
        "halui.tool.length_offset.x": {"help": "", "type": float},
        "halui.tool.length_offset.y": {"help": "", "type": float},
        "halui.tool.length_offset.z": {"help": "", "type": float},
        "halui.tool.number": {"help": "", "type": int},
        "iocontrol.0.coolant-flood": {"help": "", "type": bool},
        "iocontrol.0.coolant-mist": {"help": "", "type": bool},
        "iocontrol.0.lube": {"help": "", "type": bool},
        "iocontrol.0.tool-change": {"help": "", "type": bool},
        "iocontrol.0.tool-from-pocket": {"help": "", "type": int},
        "iocontrol.0.tool-number": {"help": "", "type": int},
        "iocontrol.0.tool-prep-index": {"help": "", "type": int},
        "iocontrol.0.tool-prep-number": {"help": "", "type": int},
        "iocontrol.0.tool-prep-pocket": {"help": "", "type": int},
        "iocontrol.0.tool-prepare": {"help": "", "type": bool},
        "iocontrol.0.user-enable-out": {"help": "", "type": bool},
        "iocontrol.0.user-request-enable": {"help": "", "type": bool},
        "joint.0.acc-cmd": {"help": "Joint", "type": float},
        "joint.0.active": {"help": "Joint", "type": bool},
        "joint.0.amp-enable-out": {"help": "Joint", "type": bool},
        "joint.0.backlash-corr": {"help": "Joint", "type": float},
        "joint.0.backlash-filt": {"help": "Joint", "type": float},
        "joint.0.backlash-vel": {"help": "Joint", "type": float},
        "joint.0.coarse-pos-cmd": {"help": "Joint", "type": float},
        "joint.0.error": {"help": "Joint", "type": bool},
        "joint.0.f-error": {"help": "Joint", "type": float},
        "joint.0.f-error-lim": {"help": "Joint", "type": float},
        "joint.0.f-errored": {"help": "Joint", "type": bool},
        "joint.0.faulted": {"help": "Joint", "type": bool},
        "joint.0.free-pos-cmd": {"help": "Joint", "type": float},
        "joint.0.free-tp-enable": {"help": "Joint", "type": bool},
        "joint.0.free-vel-lim": {"help": "Joint", "type": float},
        "joint.0.home-state": {"help": "Joint", "type": int},
        "joint.0.homed": {"help": "Joint", "type": bool},
        "joint.0.homing": {"help": "Joint", "type": bool},
        "joint.0.in-position": {"help": "Joint", "type": bool},
        "joint.0.kb-jog-active": {"help": "Joint", "type": bool},
        "joint.0.motor-offset": {"help": "Joint", "type": float},
        "joint.0.motor-pos-cmd": {"help": "Joint", "type": float},
        "joint.0.neg-hard-limit": {"help": "Joint", "type": bool},
        "joint.0.pos-cmd": {"help": "Joint", "type": float},
        "joint.0.pos-fb": {"help": "Joint", "type": float},
        "joint.0.pos-hard-limit": {"help": "Joint", "type": bool},
        "joint.0.vel-cmd": {"help": "Joint", "type": float},
        "joint.0.wheel-jog-active": {"help": "Joint", "type": bool},
        "motion-command-handler.time": {"help": "", "type": int},
        "motion-controller.time": {"help": "", "type": int},
        "motion.analog-out-00": {"help": "", "type": float},
        "motion.analog-out-01": {"help": "", "type": float},
        "motion.analog-out-02": {"help": "", "type": float},
        "motion.coord-error": {"help": "", "type": bool},
        "motion.coord-mode": {"help": "", "type": bool},
        "motion.current-vel": {"help": "", "type": float},
        "motion.digital-out-00": {"help": "Digital Output: M62-M65", "type": bool},
        "motion.digital-out-01": {"help": "Digital Output: M62-M65", "type": bool},
        "motion.digital-out-02": {"help": "Digital Output: M62-M65", "type": bool},
        "motion.digital-out-03": {"help": "Digital Output: M62-M65", "type": bool},
        "motion.distance-to-go": {"help": "", "type": float},
        "motion.eoffset-active": {"help": "", "type": bool},
        "motion.eoffset-limited": {"help": "", "type": bool},
        "motion.feed-inches-per-minute": {"help": "", "type": float},
        "motion.feed-inches-per-second": {"help": "", "type": float},
        "motion.feed-mm-per-minute": {"help": "", "type": float},
        "motion.feed-mm-per-second": {"help": "", "type": float},
        "motion.feed-upm": {"help": "", "type": float},
        "motion.in-position": {"help": "", "type": bool},
        "motion.is-all-homed": {"help": "", "type": bool},
        "motion.jog-is-active": {"help": "", "type": bool},
        "motion.motion-enabled": {"help": "", "type": bool},
        "motion.motion-type": {"help": "", "type": int},
        "motion.on-soft-limit": {"help": "", "type": bool},
        "motion.program-line": {"help": "", "type": int},
        "motion.requested-vel": {"help": "", "type": float},
        "motion.servo.last-period": {"help": "", "type": int},
        "motion.teleop-mode": {"help": "", "type": bool},
        "motion.tooloffset.a": {"help": "", "type": float},
        "motion.tooloffset.b": {"help": "", "type": float},
        "motion.tooloffset.c": {"help": "", "type": float},
        "motion.tooloffset.u": {"help": "", "type": float},
        "motion.tooloffset.v": {"help": "", "type": float},
        "motion.tooloffset.w": {"help": "", "type": float},
        "motion.tooloffset.x": {"help": "", "type": float},
        "motion.tooloffset.y": {"help": "", "type": float},
        "motion.tooloffset.z": {"help": "", "type": float},
        "motion.tp-reverse": {"help": "", "type": bool},
        "servo-thread.time": {"help": "", "type": int},
        "spindle.0.brake": {"help": "", "type": bool},
        "spindle.0.forward": {"help": "Spindle 0 Forward", "type": bool},
        "spindle.0.locked": {"help": "", "type": bool},
        "spindle.0.on": {"help": "Spindle 0 Reverse", "type": bool},
        "spindle.0.orient": {"help": "", "type": bool},
        "spindle.0.orient-angle": {"help": "", "type": float},
        "spindle.0.orient-mode": {"help": "", "type": int},
        "spindle.0.reverse": {"help": "Spindle 0 Reverse", "type": bool},
        "spindle.0.speed-cmd-rps": {"help": "", "type": float},
        "spindle.0.speed-out": {"help": "Spindle 0 Speed output", "type": float},
        "spindle.0.speed-out-abs": {"help": "Spindle 0 Speed output " "(Absolut)", "type": float},
        "spindle.0.speed-out-rps": {"help": "", "type": float},
        "spindle.0.speed-out-rps-abs": {"help": "", "type": float},
    },
}

INI_HELPTEXT = {
    "EMC": {
        "VERSION": "The version number for the configuration.",
        "MACHINE": "This is the name of the controller, which is printed out at the top of most graphical interfaces.",
        "DEBUG": "Debug level 0 means no messages will be printed when LinuxCNC is run from a <<faq:terminal,terminal>>.",
    },
    "DISPLAY": {
        "DISPLAY": "The file name of the executable providing the user interface to use.",
        "POSITION_OFFSET": "The coordinate system (`RELATIVE` or `MACHINE`) to show on the DRO when the user interface starts.",
        "POSITION_FEEDBACK": "The coordinate value (`COMMANDED` or `ACTUAL`) to show on the DRO when the user interface starts.",
        "DRO_FORMAT_MM": "Override the default DRO formatting in metric mode (normally 3 decimal places, padded with spaces to 6 digits to the left).",
        "DRO_FORMAT_IN": "Override the default DRO formatting in imperial mode (normally 4 decimal places, padded with spaces to 6 digits to the left).",
        "CONE_BASESIZE": "Override the default cone/tool base size of .5 in the graphics display.",
        "MAX_FEED_OVERRIDE": "The maximum feed override the user may select.",
        "MIN_SPINDLE_OVERRIDE": "The minimum spindle override the user may select.",
        "MIN_SPINDLE_0_OVERRIDE": "The minimum spindle override the user may select.",
        "MAX_SPINDLE_OVERRIDE": "The maximum spindle override the user may select. 1.0 means 100% of the programmed spindle speed.",
        "MAX_SPINDLE_0_OVERRIDE": "The maximum feed override the user may select.",
        "DEFAULT_SPINDLE_SPEED": "The default spindle RPM when the spindle is started in manual mode.",
        "DEFAULT_SPINDLE_0_SPEED": "The default spindle RPM when the spindle is started in manual mode.",
        "SPINDLE_INCREMENT": "The increment used when clicking increase/decrease buttons. Only used by the QtVCP based user interfaces.",
        "MIN_SPINDLE_0_SPEED": "The minimum RPM that can be manually selected.",
        "MAX_SPINDLE_0_SPEED": "The maximum RPM that can be manually selected.",
        "PROGRAM_PREFIX": "The default directory for G-code files, named subroutines, and user-defined M-codes.",
        "INTRO_GRAPHIC": "The image shown on the splash screen.",
        "INTRO_TIME": "The maximum time to show the splash screen, in seconds.",
        "CYCLE_TIME": "Cycle time of the display GUI.",
        "PREVIEW_TIMEOUT": "Timeout (in seconds) for loading graphical preview of G-code. Currently AXIS only.",
        "DEFAULT_LINEAR_VELOCITY": "The default velocity for linear jogs, in <<sub:ini:sec:traj,machine units>> per second.",
        "MIN_VELOCITY": "The approximate lowest value the jog slider.",
        "MAX_LINEAR_VELOCITY": "The maximum velocity for linear jogs, in machine units per second.",
        "MIN_LINEAR_VELOCITY": "The approximate lowest value the jog slider.",
        "DEFAULT_ANGULAR_VELOCITY": "The default velocity for angular jogs, in machine units per second.",
        "MIN_ANGULAR_VELOCITY": "The approximate lowest value the angular jog slider.",
        "MAX_ANGULAR_VELOCITY": "The maximum velocity for angular jogs, in machine units per second.",
        "INCREMENTS": "Defines the increments available for incremental jogs.",
        "GRIDS": "Defines the preset values for grid lines.",
        "OPEN_FILE": "The file to show in the preview plot when AXIS starts.",
        "EDITOR": "The editor to use when selecting File > Edit to edit the G-code from the AXIS menu.",
        "TOOL_EDITOR": "The editor to use when editing the tool table",
        "PYVCP": "The PyVCP panel description file.",
        "PYVCP_POSITION": "The placement of the PyVCP panel in the AXIS user interface.",
        "LATHE": 'Any non-empty value (including "0") causes axis to use "lathe mode" with a top view and with Radius and Diameter on the DRO.',
        "BACK_TOOL_LATHE": 'Any non-empty value (including "0") causes axis to use "back tool lathe mode" with inverted X axis.',
        "FOAM": 'Any non-empty value (including "0") causes axis to change the display for foam-cutter mode.',
        "GEOMETRY": "Controls the *preview* and *backplot* of motion.",
        "ARCDIVISION": "Set the quality of preview of arcs.",
        "MDI_HISTORY_FILE": "The name of a local MDI history file.",
        "JOG_AXES": "The order in which jog keys are assigned to axis letters.",
        "JOG_INVERT": "For each axis letter, the jog direction is inverted.",
        "USER_COMMAND_FILE": "The name of an optional, configuration-specific Python file sourced by the AXIS GUI instead of the user-specific file `~/.axisrc`.",
        "HELP_FILE": "Path to help file.",
    },
    "FILTER": {},
    "RS274NGC": {
        "PARAMETER_FILE": "(((PARAMETER FILE)))",
        "ORIENT_OFFSET": "(((ORIENT OFFSET)))",
        "RS274NGC_STARTUP_CODE": "(((RS274NGC STARTUP CODE)))",
        "SUBROUTINE_PATH": "(((SUBROUTINE PATH)))",
        "USER_M_PATH": "(((USER M PATH)))",
    },
    "EMCMOT": {
        "EMCMOT": "the motion controller name is typically used here.",
        "BASE_PERIOD": "the 'Base' task period in nanoseconds.",
        "SERVO_PERIOD": 'This is the "Servo" task period in nanoseconds.',
        "TRAJ_PERIOD": "This is the 'Trajectory Planner' task period in nanoseconds.",
        "COMM_TIMEOUT": "Number of seconds to wait for Motion (the realtime part of the motion controller) to acknowledge receipt of messages from Task (the non-realtime part of the motion controller).",
    },
    "TASK": {},
    "HAL": {
        "HALFILE": "Execute the file 'example.hal' at start up.",
        "TWOPASS": "Use twopass processing for loading HAL components.",
        "HALCMD": "Execute _command_ as a single HAL command.",
        "SHUTDOWN": "Execute the file 'shutdown.hal' when LinuxCNC is exiting.",
        "POSTGUI_HALFILE": "Execute 'example2.hal' after the GUI has created its HAL pins.",
        "HALUI": "adds the HAL user interface pins. +",
    },
    "HALUI": {},
    "APPLICATIONS": {"DELAY": "seconds to wait before starting other applications.", "APP": "Application to be started."},
    "TRAJ": {
        "ARC_BLEND_ENABLE": "Turn on new TP.",
        "ARC_BLEND_FALLBACK_ENABLE": "Optionally fall back to parabolic blends if the estimated speed is faster.",
        "ARC_BLEND_OPTIMIZATION_DEPTH": "Look ahead depth in number of segments.",
        "ARC_BLEND_RAMP_FREQ": "This is a 'cutoff' frequency for using ramped velocity.",
        "SPINDLES": 'The number of spindles to support. It is imperative that this number matches the "num_spindles" parameter passed to the motion module.',
        "COORDINATES": "The names of the axes being controlled.  Only X, Y, Z, A, B, C, U, V, W are valid.",
        "LINEAR_UNITS": "(((LINEAR UNITS))) Specifies the 'machine units' for linear axes.",
        "ANGULAR_UNITS": "(((ANGULAR UNITS))) Specifies the 'machine units' for rotational axes.",
        "DEFAULT_LINEAR_VELOCITY": "The initial rate for jogs of linear axes, in machine units per second.",
        "DEFAULT_LINEAR_ACCELERATION": "In machines with nontrivial kinematics, the acceleration used for \"teleop\" (Cartesian space) jogs, in 'machine units' per second per second.",
        "MAX_LINEAR_VELOCITY": "(((MAX VELOCITY))) The maximum velocity for any axis or coordinated move, in 'machine units' per second.",
        "MAX_LINEAR_ACCELERATION": "(((MAX ACCELERATION))) The maximum acceleration for any axis or coordinated axis move, in 'machine units' per second per second.",
        "POSITION_FILE": "If set to a non-empty value, the joint positions are stored between runs in this file.",
        "NO_FORCE_HOMING": "The default behavior is for LinuxCNC to force the user to home the machine before any MDI command or a program is run.",
        "HOME": "World home position needed for kinematics modules that compute world coordinates using kinematicsForward() when switching from joint to teleop mode.",
        "NO_PROBE_JOG_ERROR": "Allow to bypass probe tripped check when you jog manually.",
        "NO_PROBE_HOME_ERROR": "Allow to bypass probe tripped check when homing is in progress.",
    },
    "KINS": {"JOINTS": "Specifies the number of joints (motors) in the system.", "KINEMATICS": "Specify a kinematics module for the motion module."},
    "AXIS_LETTER": {
        "MAX_VELOCITY": "Maximum velocity for this axis in <<sub:ini:sec:traj,machine units>> per second.",
        "MAX_ACCELERATION": "Maximum acceleration for this axis in machine units per second squared.",
        "MIN_LIMIT": "(((MIN LIMIT))) The minimum limit (soft limit) for axis motion, in machine units.",
        "MAX_LIMIT": "(((MAX LIMIT))) The maximum limit (soft limit) for axis motion, in machine units.",
        "WRAPPED_ROTARY": "When this is set to 1 for an ANGULAR axis the axis will move 0-359.999 degrees.",
        "LOCKING_INDEXER_JOINT": "This value selects a joint to use for a locking indexer for the specified axis _<letter>_.",
        "OFFSET_AV_RATIO": "If nonzero, this item enables the use of HAL input pins for external axis offsets:",
    },
    "JOINT_NUM": {
        "TYPE": "The type of joint, either `LINEAR` or `ANGULAR`.",
        "UNITS": "UNITS",
        "MAX_VELOCITY": "Maximum velocity for this joint in <<sub:ini:sec:traj,machine units>> per second.",
        "MAX_ACCELERATION": "Maximum acceleration for this joint in machine units per second squared.",
        "BACKLASH": "Backlash in machine units.",
        "COMP_FILE": "Compensation file",
        "COMP_FILE_TYPE": "Specifies the type of compensation file.",
        "MIN_LIMIT": "minimum limit",
        "MAX_LIMIT": "maximum  limit",
        "MIN_FERROR": "the maximum allowable following error, in machine units. (slow movements)",
        "FERROR": "the maximum allowable following error, in machine units. (fast movements)",
        "LOCKING_INDEXER": "Indicates the joint is used as a locking indexer.",
        "HOME": "The position that the joint will go to upon completion of the homing sequence.",
        "HOME_SEARCH_VEL": "Initial homing velocity in machine units per second.",
        "HOME_ABSOLUTE_ENCODER": "Used to indicate the joint uses an absolute encoder.",
        "HOME_SEQUENCE": 'Used to define the "Home All" sequence.',
        "HOME_LATCH_VEL": "Specifies the speed and direction that LinuxCNC uses when it makes its final accurate determination of the home switch (if present) and index pulse location (if present)",
        "HOME_FINAL_VEL": "It specifies the speed that LinuxCNC uses when it makes its move from HOME_OFFSET to the HOME position",
        "HOME_USE_INDEX": "Specifies whether or not there is an index pulse",
        "HOME_OFFSET": "Contains the location of the home switch or index pulse, in joint coordinates",
        "HOME_IGNORE_LIMITS": "This flag determines whether LinuxCNC will ignore the limit switch inputs",
        "DEADBAND": "How close is close enough to consider the motor in position, in machine units",
        "BIAS": "This is used by hm2-servo and some others.",
        "P": "The proportional gain for the joint servo.",
        "I": "The integral gain for the joint servo.",
        "D": "The derivative gain for the joint servo.",
        "FF0": "The 0^th^ order feed forward gain.",
        "FF1": "The 1^st^ order feed forward gain.",
        "FF2": "The 2^nd^ order feed forward gain.",
        "MAX_OUTPUT": "The maximum value for the output of the PID compensation that is written to the motor amplifier, in volts.",
        "INPUT_SCALE": "in Sample configs",
        "ENCODER_SCALE": "in PnCconf built configs",
        "SCALE": "in Sample configs",
        "STEP_SCALE": "in PnCconf built configs",
        "STEPGEN_MAXACCEL": " Acceleration limit for the step generator.",
        "STEPGEN_MAXVEL": "Older configuration files have a velocity limit for the step generator as well.",
        "FEEDBACK": "the feedback signal for this joint (plugin_name[:signal_name]) - closed loop",
    },
    "SPINDLE_NUM": {"HOME_SEARCH_VELOCITY": "FIXME: Spindle homing not yet working.", "HOME_SEQUENCE": "FIXME: Spindle homing not yet working"},
    "EMCIO": {
        "EMCIO": "Name of IO controller program.",
        "CYCLE_TIME": "The period, in seconds, at which EMCIO will run.",
        "TOOL_TABLE": "The file which contains tool information, described in the User Manual.",
        "DB_PROGRAM": "Path to an executable program that manages tool data.",
    },
}
